// TabCANOpen2.cpp : implementation file
//

#include "stdafx.h"
#include "TabPage2.h"
#include "DlgXmeter.h"
#include "../../Lib/cfg/MsgFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgXMeterPage2 dialog


CDlgXMeterPage2::CDlgXMeterPage2(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgXMeterPage2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgXMeterPage2)
	m_db = 0;
	m_type = FALSE;
	m_id1 = 0;
	m_id2 = 0;
	m_st_ext = FALSE;
	m_scale = 1.0;
	m_color = 0;
	m_warning = FALSE;
	m_war_if = 0;
	m_war_limit = 0.0;
	//}}AFX_DATA_INIT
}


void CDlgXMeterPage2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgXMeterPage2)
	DDX_Radio(pDX, IDC_DB0, m_db);
	DDX_Check(pDX, IDC_TYPE, m_type);
	DDX_Text(pDX, IDC_ID1, m_id1);
	DDX_Text(pDX, IDC_ID2, m_id2);
	DDX_Check(pDX, IDC_ST_EXT, m_st_ext);
	DDX_Text(pDX, IDC_SCALE, m_scale);
	DDX_Radio(pDX, IDC_COLOR, m_color);
	DDX_Check(pDX, IDC_WARNING, m_warning);
	DDX_Radio(pDX, IDC_WAR_IF, m_war_if);
	DDX_Text(pDX, IDC_LIMIT, m_war_limit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgXMeterPage2, CDialog)
	//{{AFX_MSG_MAP(CDlgXMeterPage2)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_BN_CLICKED(IDC_TYPE, OnType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CDlgXMeterPage2::OnSave() 
{
	CFileDialog *dialog = new CFileDialog(false, "ppp");
	dialog->m_ofn.lpstrFilter = "Config files *.ppp\0*.PPP\0All files *.*\0*.*\0";
	if( dialog->DoModal() == IDOK ) {
		OnSet();
		cWConfigFile *config = new cWConfigFile();
		CString filename = dialog->GetPathName();
		config->set_name((char*)filename.GetBuffer(3));
		//int length;
		unsigned int  iValue;
		bool bValue;
		float dValue;
		iValue = m_db;
		config->WriteUInt("dMeter","db",iValue);
		iValue = m_id1;
		config->WriteUInt("dMeter","id1",iValue);
		iValue = m_id2;
		config->WriteUInt("dMeter","id2",iValue);
		iValue = m_color;
		config->WriteUInt("dMeter","color",iValue);
		iValue = m_war_if;
		config->WriteUInt("dMeter","war_if",iValue);


		bValue = (bool)m_type;
		config->WriteBool("dMeter","type",bValue);
		bValue = (bool)m_st_ext;
		config->WriteBool("dMeter","st_ext",bValue);
		bValue = (bool)m_warning;
		config->WriteBool("dMeter","warning",bValue);

		dValue = (float)m_scale;
 		config->WriteFloat("dMeter","scale",dValue);
		dValue = (float)m_war_limit;
 		config->WriteFloat("dMeter","war_limit",dValue);
	}
}

void CDlgXMeterPage2::OnLoad() 
{
	CFileDialog *dialog = new CFileDialog(true, "ppp");
	dialog->m_ofn.lpstrFilter = "Config files *.ppp\0*.PPP\0All files *.*\0*.*\0";
	if( dialog->DoModal() == IDOK ) {
		cWConfigFile *config = new cWConfigFile();
		CString filename = dialog->GetPathName();
		config->set_name((char*)filename.GetBuffer(3));
		//int length;
		unsigned int  iValue;
		bool bValue;
		float dValue;
		config->ReadUInt("dMeter","db",&iValue,"0"); m_db = iValue;
		config->ReadUInt("dMeter","id1",&iValue,"0"); m_id1 = iValue;
		config->ReadUInt("dMeter","id2",&iValue,"0"); m_id2 = iValue;
		config->ReadUInt("dMeter","color",&iValue,"0"); m_color = iValue;
		config->ReadUInt("dMeter","war_if",&iValue,"0"); m_war_if = iValue;

		config->ReadBool("dMeter","type",&bValue,"0"); m_type = (BOOL)bValue;
		config->ReadBool("dMeter","st_ext",&bValue,"0"); m_st_ext = (BOOL)bValue;
		config->ReadBool("dMeter","warning",&bValue,"0"); m_warning = (BOOL)bValue;

		config->ReadFloat("dMeter","scale",&dValue,"0"); m_scale = dValue;
		config->ReadFloat("dMeter","war_limit",&dValue,"100"); m_war_limit = dValue;

		UpdateData(FALSE);
		OnSet();
	}	
}

void CDlgXMeterPage2::OnSet() 
{
	UpdateData(TRUE);
	id1 = m_id1;
	id2 = m_id2;
	st_ext = (bool)m_st_ext;
	db = m_db;
	type = (bool)m_type;
	data_scale = m_scale;
	color = m_color;
	warning = (bool)m_warning;
	war_if = m_war_if;
	war_limit = m_war_limit;

}

void CDlgXMeterPage2::OnType() 
{
	UpdateData(TRUE);
	CWnd* pWnd;
	pWnd = GetDlgItem(IDC_DB7);
	if(m_type)		 pWnd->EnableWindow(FALSE);
	else			 pWnd->EnableWindow(TRUE);
}
